package com.massivecraft.factions.cmd;

import com.massivecraft.factions.Factions;
import com.massivecraft.factions.entity.MConf;
import com.massivecraft.massivecore.command.MassiveCommandDeprecated;
import com.massivecraft.massivecore.command.MassiveCommandVersion;

import java.util.List;

public class CmdFactions extends FactionsCommand {
    // -------------------------------------------- //
    // INSTANCE
    // -------------------------------------------- //

    protected static CmdFactions i = new CmdFactions();

    public static CmdFactions get() {
        return i;
    }

    // -------------------------------------------- //
    // FIELDS
    // -------------------------------------------- //

    public CmdFactionsDocumentation cmdFactionsDocumentation = new CmdFactionsDocumentation();
    public CmdFactionsList cmdFactionsList = new CmdFactionsList();
    public CmdFactionsFaction cmdFactionsFaction = new CmdFactionsFaction();
    public CmdFactionsPlayer cmdFactionsPlayer = new CmdFactionsPlayer();
    public CmdFactionsStatus cmdFactionsStatus = new CmdFactionsStatus();
    public CmdFactionsJoin cmdFactionsJoin = new CmdFactionsJoin();
    public final CmdFactionsLeave cmdFactionsLeave = new CmdFactionsLeave();
    public final CmdFactionsWarp cmdFactionsWarp = new CmdFactionsWarp();
    public CmdFactionsHome cmdFactionsHome = new CmdFactionsHome();
    public CmdFactionsSethome cmdFactionsSethome = new CmdFactionsSethome();
    public CmdFactionsUnsethome cmdFactionsUnsethome = new CmdFactionsUnsethome();
    public final CmdFactionsVote cmdFactionsVote = new CmdFactionsVote();
    public CmdFactionsMap cmdFactionsMap = new CmdFactionsMap();
    public final CmdFactionsCreate cmdFactionsCreate = new CmdFactionsCreate();
    public final CmdFactionsName cmdFactionsName = new CmdFactionsName();
    public final CmdFactionsDescription cmdFactionsDescription = new CmdFactionsDescription();
    public CmdFactionsMotd cmdFactionsMotd = new CmdFactionsMotd();
    public final CmdFactionsInvite cmdFactionsInvite = new CmdFactionsInvite();
    public final CmdFactionsKick cmdFactionsKick = new CmdFactionsKick();
    public final CmdFactionsTitle cmdFactionsTitle = new CmdFactionsTitle();
    public final CmdFactionsRank cmdFactionsRank = new CmdFactionsRank();
    public CmdFactionsMoney cmdFactionsMoney = new CmdFactionsMoney();
    public CmdFactionsTop cmdFactionsTop = new CmdFactionsTop();
    public CmdFactionsSeeChunk cmdFactionsSeeChunk = new CmdFactionsSeeChunk();
    public CmdFactionsSeeChunkOld cmdFactionsSeeChunkOld = new CmdFactionsSeeChunkOld();
    public CmdFactionsTerritorytitles cmdFactionsTerritorytitles = new CmdFactionsTerritorytitles();
    public CmdFactionsClaim cmdFactionsClaim = new CmdFactionsClaim();
    public CmdFactionsUnclaim cmdFactionsUnclaim = new CmdFactionsUnclaim();
    public CmdFactionsAccess cmdFactionsAccess = new CmdFactionsAccess();
    public CmdFactionsChunkname cmdFactionsChunkname = new CmdFactionsChunkname();
    public final CmdFactionsRelation cmdFactionsRelation = new CmdFactionsRelation();
    public CmdFactionsRelationOld cmdFactionsRelationOldAlly = new CmdFactionsRelationOld("ally");
    public CmdFactionsRelationOld cmdFactionsRelationOldTruce = new CmdFactionsRelationOld("truce");
    public CmdFactionsRelationOld cmdFactionsRelationOldNeutral = new CmdFactionsRelationOld("neutral");
    public CmdFactionsRelationOld cmdFactionsRelationOldEnemy = new CmdFactionsRelationOld("enemy");
    public CmdFactionsTax cmdFactionsTax = new CmdFactionsTax();
    public final CmdFactionsPerm cmdFactionsPerm = new CmdFactionsPerm();
    public final CmdFactionsFlag cmdFactionsFlag = new CmdFactionsFlag();
    public CmdFactionsFly cmdFactionsFly = new CmdFactionsFly();
    public CmdFactionsUnstuck cmdFactionsUnstuck = new CmdFactionsUnstuck();
    public final CmdFactionsOverride cmdFactionsOverride = new CmdFactionsOverride();
    public CmdFactionsDisband cmdFactionsDisband = new CmdFactionsDisband();
    public CmdFactionsPowerboost cmdFactionsPowerBoost = new CmdFactionsPowerboost();
    public CmdFactionsSetpower cmdFactionsSetpower = new CmdFactionsSetpower();
    public CmdFactionsMoneyconvert cmdFactionsMoneyconvert = new CmdFactionsMoneyconvert();
    public CmdFactionsConfig cmdFactionsConfig = new CmdFactionsConfig();
    public CmdFactionsClean cmdFactionsClean = new CmdFactionsClean();
    public MassiveCommandVersion cmdFactionsVersion = new MassiveCommandVersion(Factions.get());

    // -------------------------------------------- //
    // CONSTRUCT
    // -------------------------------------------- //

    public CmdFactions() {
        // Old rank stuff
        this.addChild(new CmdFactionsRankOld("demote"));
        this.addChild(new CmdFactionsRankOld("promote"));

        // Deprecated Commands
        this.addChild(new MassiveCommandDeprecated(this.cmdFactionsRank, "leader", "owner", "officer", "moderator", "coleader"));
    }

    // -------------------------------------------- //
    // OVERRIDE
    // -------------------------------------------- //

    @Override
    public List<String> getAliases() {
        return MConf.get().aliasesF;
    }

}
