package com.massivecraft.factions.integration.lockette;

import com.massivecraft.factions.engine.ProtectCase;
import com.massivecraft.factions.entity.BoardColl;
import com.massivecraft.factions.entity.Faction;
import com.massivecraft.factions.entity.MConf;
import com.massivecraft.factions.entity.MPerm;
import com.massivecraft.factions.entity.MPlayer;
import com.massivecraft.massivecore.Engine;
import com.massivecraft.massivecore.ps.PS;
import me.crafter.mc.lockettepro.LocketteProAPI;
import org.bukkit.block.Block;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.block.BlockBreakEvent;

public class EngineLockette extends Engine {

    // -------------------------------------------- //
    // INSTANCE & CONSTRUCT
    // -------------------------------------------- //

    protected static EngineLockette i = new EngineLockette();

    public static EngineLockette get() {
        return i;
    }

    @EventHandler(priority = EventPriority.HIGHEST)
    public void onLocketteBreak(BlockBreakEvent event) {
        Block block = event.getBlock();
        // Check if we are dealing with a protection sign, and overriding is enabled
        if (!event.isCancelled() || (!LocketteProAPI.isLockSign(block) && !LocketteProAPI.isAdditionalSign(block)) ||
                !MConf.get().locketteLeaderRemoveOverride) {
            return;
        }

        // If in wilderness, don't allow any overrides
        PS ps = PS.valueOf(block);
        Faction hostFaction = BoardColl.get().getFactionAt(ps);
        if (hostFaction.isNone()) {
            return;
        }

        MPlayer player = MPlayer.get(event.getPlayer());
        MPerm perm = ProtectCase.BUILD.getPerm(block);

        // Only allow if the player is the leader of the faction the sign is in
        if (player.getFaction() != hostFaction || !player.getRank().isLeader()) {
            return;
        }

        // Require build permissions to remove the lockette sign
        if (perm != null && perm.has(player, ps, false)) {
            event.setCancelled(false);
        }
    }

}
