package com.massivecraft.factions.integration.placeholderapi;

import com.massivecraft.factions.Factions;
import com.massivecraft.factions.entity.BoardColl;
import com.massivecraft.factions.entity.MPlayer;
import me.clip.placeholderapi.expansion.PlaceholderExpansion;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.NotNull;

import java.text.DecimalFormat;

public class PlaceholderFactions extends PlaceholderExpansion {
    // -------------------------------------------- //
    // INSTANCE & CONSTRUCT
    // -------------------------------------------- //

    protected static PlaceholderFactions i = new PlaceholderFactions();

    public static PlaceholderFactions get() {
        return i;
    }

    // -------------------------------------------- //
    // OVERRIDE
    // -------------------------------------------- //

    @Override
    public @NotNull String getIdentifier() {
        return "factions";
    }

    @Override
    public @NotNull String getAuthor() {
        return "Madus";
    }

    @Override
    public @NotNull String getVersion() {
        return Factions.get().getDescription().getVersion();
    }

    @Override
    public String onPlaceholderRequest(Player player, @NotNull String params) {
        if (player == null) {
            return null;
        }

        MPlayer mplayer = MPlayer.get(player);
        if ("role".equals(params)) {
            params = "rank";
        }
        DecimalFormat df = new DecimalFormat("#.##");

        return switch (params) {
            case "faction" -> mplayer.getFaction().getName();
            case "power" -> df.format(mplayer.getPower());
            case "powermax" -> df.format(mplayer.getPowerMax());
            case "factionpower" -> df.format(mplayer.getFaction().getPower());
            case "factionpowermax" -> df.format(mplayer.getFaction().getPowerMax());
            case "title" -> mplayer.getTitle();
            case "rank" -> mplayer.getRank().getName();
            case "claims" ->
                    Long.toString(BoardColl.get().getAll().stream().mapToInt(board -> board.getCount(mplayer.getFaction())).sum());
            case "onlinemembers" -> Integer.toString(mplayer.getFaction().getMPlayersWhereOnlineTo(mplayer).size());
            case "allmembers" -> Integer.toString(mplayer.getFaction().getMPlayers().size());
            default -> null;
        };
    }

}
